<?xml version="1.0" encoding="UTF-8"?>
<!--
	XSLT for transforming NewsCodes provided as an IPTC G2 Knowledge Item into an RDF/Turtle+SKOS instance.
	(c) 2011, IPTC - www.iptc.org
	See license for using this file at: http://www.iptc.org/goto?license
	Author: Michael Steidl, IPTC
	Version:
	v3 2011-03-28
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://iptc.org/std/nar/2006-10-01/" xmlns:nar="http://iptc.org/std/nar/2006-10-01/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:skos="http://www.w3.org/2004/02/skos/core#">
	<xsl:output method="text" version="1.0" encoding="UTF-8" indent="no"/>
	<xsl:template match="/">
@prefix rdf:	&lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt;.
@prefix skos:	&lt;http://www.w3.org/2004/02/skos/core#&gt;.
@prefix owl:	&lt;http://www.w3.org/2002/07/owl#&gt;.
<!-- this is a list of all prefixes used by IPTC vocabularies -->
@prefix acdc: &lt;http://cv.iptc.org/newscodes/audiocodec/&gt;.
@prefix prov: &lt;http://cv.iptc.org/newscodes/provider/&gt;.
@prefix scn: &lt;http://cv.iptc.org/newscodes/scene/&gt;.
@prefix subj: &lt;http://cv.iptc.org/newscodes/subjectcode/&gt;.
@prefix squ: &lt;http://cv.iptc.org/newscodes/subjectqualifier/&gt;.
@prefix vcdc: &lt;http://cv.iptc.org/newscodes/videocodec/&gt;.
@prefix ninat: &lt;http://cv.iptc.org/newscodes/ninature/&gt;.
@prefix cinat: &lt;http://cv.iptc.org/newscodes/cinature/&gt;.
@prefix cpnat: &lt;http://cv.iptc.org/newscodes/cpnature/&gt;.
@prefix mtyp: &lt;http://cv.iptc.org/newscodes/mediatype/&gt;.
@prefix drol: &lt;http://cv.iptc.org/newscodes/descriptionrole/&gt;.
@prefix erol: &lt;http://cv.iptc.org/newscodes/edrole/&gt;.
@prefix irel: &lt;http://cv.iptc.org/newscodes/itemrelation/&gt;.
@prefix irep: &lt;http://cv.iptc.org/newscodes/itemrepresentation/&gt;.
@prefix pgrmod: &lt;http://cv.iptc.org/newscodes/pkggroupmode/&gt;.
@prefix stat: &lt;http://cv.iptc.org/newscodes/pubstatusg2/&gt;.
@prefix rnd: &lt;http://cv.iptc.org/newscodes/rendition/&gt;.
@prefix nrol: &lt;http://cv.iptc.org/newscodes/namerole/&gt;.
@prefix nprt: &lt;http://cv.iptc.org/newscodes/namepart/&gt;.
@prefix why: &lt;http://cv.iptc.org/newscodes/whypresent/&gt;.
@prefix isrol: &lt;http://cv.iptc.org/newscodes/infosourcerole/&gt;.
@prefix lrol: &lt;http://cv.iptc.org/newscodes/languagerole/&gt;.
@prefix ciprol: &lt;http://cv.iptc.org/newscodes/contactinfopartrole/&gt;.
@prefix ctech: &lt;http://cv.iptc.org/newscodes/commtech/&gt;.
@prefix edconf: &lt;http://cv.iptc.org/newscodes/eventdateconfirm/&gt;.
@prefix eocstat: &lt;http://cv.iptc.org/newscodes/eventoccurstatus/&gt;.
@prefix eregrol: &lt;http://cv.iptc.org/newscodes/eventregrole/&gt;.
@prefix eprol: &lt;http://cv.iptc.org/newscodes/eventparticipantrole/&gt;.
@prefix eorol: &lt;http://cv.iptc.org/newscodes/eventorganiserrole/&gt;.
@prefix ecirol: &lt;http://cv.iptc.org/newscodes/eventcontactinforole/&gt;.
@prefix econf: &lt;http://cv.iptc.org/newscodes/eventdateconfirm/&gt;.
@prefix chprop: &lt;http://cv.iptc.org/newscodes/characteristicsproperty/&gt;.
@prefix colsp: &lt;http://cv.iptc.org/newscodes/colorspace/&gt;.
@prefix conf: &lt;http://cv.iptc.org/newscodes/confidence/&gt;.
@prefix encd: &lt;http://cv.iptc.org/newscodes/encoding/&gt;.
@prefix frmt: &lt;http://cv.iptc.org/newscodes/format/&gt;.
@prefix genre: &lt;http://cv.iptc.org/newscodes/genre/&gt;.
@prefix howpr: &lt;http://cv.iptc.org/newscodes/howpresent/&gt;.
@prefix impt: &lt;http://cv.iptc.org/newscodes/importance/&gt;.
@prefix lbtyp: &lt;http://cv.iptc.org/newscodes/labeltype/&gt;.
@prefix loctyp: &lt;http://cv.iptc.org/newscodes/location/&gt;.
@prefix medtyp: &lt;http://cv.iptc.org/newscodes/mediatype/&gt;.
@prefix nityp: &lt;http://cv.iptc.org/newscodes/newsitemtype/&gt;.
@prefix not: &lt;http://cv.iptc.org/newscodes/notation/&gt;.
@prefix oito: &lt;http://cv.iptc.org/newscodes/ofinterestto/&gt;.
@prefix prio: &lt;http://cv.iptc.org/newscodes/priority/&gt;.
@prefix prop: &lt;http://cv.iptc.org/newscodes/property/&gt;.
@prefix rel: &lt;http://cv.iptc.org/newscodes/relevance/&gt;.
@prefix role1: &lt;http://cv.iptc.org/newscodes/role1/&gt;.
@prefix pst1: &lt;http://cv.iptc.org/newscodes/status1/&gt;.
@prefix tpctyp: &lt;http://cv.iptc.org/newscodes/topictype/&gt;.
@prefix urgy: &lt;http://cv.iptc.org/newscodes/urgency/&gt;.
@prefix medtop: &lt;http://cv.iptc.org/newscodes/mediatopic/&gt;.
@prefix wldreg: &lt;http://cv.iptc.org/newscodes/worldregion/&gt;.
@prefix ncostat: &lt;http://cv.iptc.org/newscodes/newscoveragestatus/&gt;.
@prefix iso3166-1a2: &lt;http://cvx.iptc.org/iso3166-1a2/&gt;.
@prefix iso3166-1a3: &lt;http://cvx.iptc.org/iso3166-1a3/&gt;.
@prefix iso4217a: &lt;http://cvx.iptc.org/iso4217a/&gt;.
@prefix iso4217n: &lt;http://cvx.iptc.org/iso4217n/&gt;.
@prefix isin: &lt;http://cvx.iptc.org/isin/&gt;.
@prefix nprov: &lt;http://cv.iptc.org/newscodes/newsprovider/&gt;.
@prefix nprod: &lt;http://cv.iptc.org/newscodes/newsproduct/&gt;.
@prefix digsrctype: &lt;http://cv.iptc.org/newscodes/digitalsourcetype/&gt;.
@prefix dummy: &lt;http://cv.iptc.org/newscodes/dummy/&gt;.
@prefix timeunit: &lt;http://cv.iptc.org/newscodes/timeunit/&gt;.
@prefix dimensionunit: &lt;http://cv.iptc.org/newscodes/dimensionunit/&gt;.
@prefix crel: &lt;http://cv.iptc.org/newscodes/conceptrelation/&gt;.
@prefix cwarn: &lt;http://cv.iptc.org/newscodes/contentwarning/&gt;.
@prefix sig: &lt;http://cv.iptc.org/newscodes/signal/&gt;.
@prefix app: &lt;http://cv.iptc.org/newscodes/application/&gt;.
@prefix plinat: &lt;http://cv.iptc.org/newscodes/plinature/&gt;.
@prefix riaspect: &lt;http://cv.iptc.org/newscodes/riaspect/&gt;.
@prefix riscope: &lt;http://cv.iptc.org/newscodes/riscope/&gt;.
@prefix hopaction: &lt;http://cv.iptc.org/newscodes/hopaction/&gt;.
@prefix hatarget : &lt;http://cv.iptc.org/newscodes/hopactiontarget/&gt;.
@prefix hashtype : &lt;http://cv.iptc.org/newscodes/hashtype/&gt;.
@prefix hashscope : &lt;http://cv.iptc.org/newscodes/hashscope/&gt;.

			<xsl:apply-templates select="//nar:conceptSet" mode="SchemeList"/>
		<xsl:apply-templates select="//nar:conceptSet" mode="Concepts"/>
	</xsl:template>
	<!-- ********* Template to create the SKOS Concept Scheme class -->
	<xsl:template match="nar:conceptSet" mode="SchemeList">
		<xsl:text>&#x0D;&#x0A;&lt;http://cv.iptc.org/newscodes/mediatopic/&gt; &#x0D;&#x0A;</xsl:text>
		<xsl:text>	rdf:type skos:ConceptScheme</xsl:text>
		<!-- the selection below builds on the style of IPTC-delivered KIs to provide broader elements for all children in a taxonomy tree
					Thus the concepts with no broader elements are the concepts at the top level -->
		<xsl:for-each select="nar:concept[count(nar:broader) = 0]">
			<xsl:text>;&#x0D;&#x0A;	skos:HasTopConcept		</xsl:text>
			<xsl:value-of select="nar:conceptId/@qcode"/>
		</xsl:for-each>
		<xsl:text>.&#x0D;&#x0A;</xsl:text>
	</xsl:template>
	<!-- ********* Template to create individual SKOS Concept classes -->
	<xsl:template match="nar:conceptSet" mode="Concepts">
		<xsl:for-each select="nar:concept">
			<xsl:text>&#x0D;&#x0A;</xsl:text>
			<xsl:value-of select="nar:conceptId/@qcode"/>
			<xsl:text>&#x0D;&#x0A;	rdf:type skos:Concept;</xsl:text>
			<xsl:for-each select="nar:name">
				<xsl:text>&#x0D;&#x0A;	skos:prefLabel	"</xsl:text>
				<xsl:value-of select="."/>
				<xsl:text>"@</xsl:text>
				<xsl:value-of select="@xml:lang"/>
				<xsl:text>;</xsl:text>
			</xsl:for-each>
			<xsl:for-each select="nar:definition">
				<xsl:text>&#x0D;&#x0A;	skos:definition	"</xsl:text>
				<xsl:value-of select="."/>
				<xsl:text>"@</xsl:text>
				<xsl:value-of select="@xml:lang"/>
				<xsl:text>;</xsl:text>
			</xsl:for-each>
			<xsl:for-each select="nar:note">
				<xsl:text>&#x0D;&#x0A;	skos:historyNote	"</xsl:text>
				<xsl:value-of select="."/>
				<xsl:text>"@</xsl:text>
				<xsl:value-of select="@xml:lang"/>
				<xsl:text>;</xsl:text>
			</xsl:for-each>
			<xsl:text>&#x0D;&#x0A;	skos:inScheme &lt;http://cv.iptc.org/newscodes/mediatopic/&gt;</xsl:text>
			<xsl:for-each select="nar:related">
					<xsl:choose>
						<xsl:when test="@rel='skos:exactMatch' ">
						<xsl:text>;&#x0D;&#x0A;	skos:exactMatch subj:</xsl:text>
						<xsl:value-of select="substring-after(@qcode,':')"/>
						</xsl:when>
						<xsl:when test="@rel='skos:closeMatch' ">
						<xsl:text>;&#x0D;&#x0A;	skos:closeMatch subj:</xsl:text>
						<xsl:value-of select="substring-after(@qcode,':')"/>
						</xsl:when>
						<xsl:when test="@rel='skos:broadMatch' ">
						<xsl:text>;&#x0D;&#x0A;	skos:broadMatch subj:</xsl:text>
						<xsl:value-of select="substring-after(@qcode,':')"/>
						</xsl:when>
						<xsl:when test="@rel='skos:narrowMatch' ">
						<xsl:text>;&#x0D;&#x0A;	skos:narrowMatch subj:</xsl:text>
						<xsl:value-of select="substring-after(@qcode,':')"/>
						</xsl:when>
						<xsl:when test="@rel='skos:relatedMatch' ">
						<xsl:text>;&#x0D;&#x0A;	skos:relatedMatch subj:</xsl:text>
						<xsl:value-of select="substring-after(@qcode,':')"/>
						</xsl:when>
					</xsl:choose>
			</xsl:for-each>
			<xsl:for-each select="nar:broader">
				<xsl:text>;&#x0D;&#x0A;	skos:broaderTransitive	</xsl:text>
				<xsl:value-of select="@qcode"/>
			</xsl:for-each>
			<!-- create narrower relationships: inverted selection: narrower concepts are concepts with a broader element referring to "this" concept -->
			<xsl:variable name="thisQCode">
				<xsl:value-of select="./nar:conceptId/@qcode"/>
			</xsl:variable>
			<xsl:for-each select="../nar:concept[nar:broader/@qcode=$thisQCode]">
				<xsl:text>;&#x0D;&#x0A;	skos:narrower	</xsl:text>
				<xsl:value-of select="nar:conceptId/@qcode"/>
			</xsl:for-each>
			<xsl:text>.&#x0D;&#x0A;</xsl:text>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>
